package es.upm.fi.dia.ontology.webode.wpbs;

public class benchmarkConstants
{
	static final String MINERVA_URL  = "minerva://localhost:2000";
	static final String MINERVA_USER = "admin";
	static final String MINERVA_GROUP = "admin";
	static final String MINERVA_PASS = "admin";
	
	static final String destination_dir = "D:\\rgarcia\\resultados\\";
	static String timer_destination_dir = destination_dir;
	
	static int factor	= 0;					// Load factor
	static int n_times	= 0;				// Number of times a method is run in a benchmark
	static int warming = 0;  				// Number of iterations before starting measuring 
	static boolean restore = false; // Whether the initial state is restored after executing a benchmark

	static int initial_state_factor	= 0;			// Factor for creating initial states
	
	
	// Las siguientes son para ejecutar el merge
	static final String merge_log_file = "D:\\rgarcia\\FILE_NAME.log";
	static final String merge_table1 = "D:\\rgarcia\\table1.txt";
	static final String merge_table2 = "D:\\rgarcia\\table2.txt";	
	
	static int TEST_ONTOLOGIES = 								0;
	static int TEST_CONCEPTS = 									TEST_ONTOLOGIES; // = ONTOLOGIES
	static int TEST_TERM_REFERENCES = 					TEST_CONCEPTS; // = ONTOLOGIES = CONCEPTS
	static int TEST_ONTOLOGY_REFERENCES = 			TEST_ONTOLOGIES; // = ONTOLOGIES
	static int TEST_TERM_REFERENCE_RELATIONS =  TEST_TERM_REFERENCES; // = ONTOLOGIES = CONCEPTS = TERM_REFERENCES 
	static int TEST_TERM_RELATIONS = 						TEST_CONCEPTS-1; // = CONCEPTS-1 = ONTOLOGIES
	static int TEST_CLASS_ATTRIBUTES = 					TEST_CONCEPTS; // = CONCEPTS = ONTOLOGIES
	static int TEST_CLASS_ATTRIBUTE_VALUES = 		TEST_CLASS_ATTRIBUTES; // = CLASS_ATTRIBUTES
	static int TEST_INSTANCE_ATTRIBUTES = 			TEST_CONCEPTS; // = CONCEPTS
	static int TEST_INSTANCE_ATTRIBUTE_VALUES = TEST_INSTANCE_ATTRIBUTES; // = INSTANCE_ATTRIBUTES
	static int TEST_SYNONYMS = 									TEST_CONCEPTS; // = CONCEPTS
	static int TEST_IMPORTED_TERMS = 						TEST_ONTOLOGIES; // = ONTOLOGIES
	static int TEST_CONSTANTS = 								TEST_ONTOLOGIES; // = ONTOLOGIES
	static int TEST_FORMULAS = 									TEST_CONCEPTS; // = ONTOLOGIES
	static int TEST_FORMULA_RELATIONS = 				TEST_FORMULAS; // = ONTOLOGIES = CONCEPTS = FORMULAS
	static int TEST_INSTANCE_SETS = 						TEST_ONTOLOGIES; // Not tested but used for TEST_INSTANCES
	static int TEST_INSTANCES = 								TEST_ONTOLOGIES; // = ONTOLOGIES = INSTANCE_SETS
	static int TEST_RELATION_INSTANCES = 				TEST_INSTANCES-1; // = TERM_RELATIONS = INSTANCES-1 = ONTOLOGIES = INSTANCE_SETS
	static int TEST_INSTANCE_VALUES = 					TEST_INSTANCE_ATTRIBUTES; // = ONTOLOGIES = INSTANCE_ATTRIBUTES
	static int TEST_GROUPS = 										TEST_CONCEPTS; // = ONTOLOGIES = CONCEPTS
	static int TEST_AXIOMS = 										TEST_CONCEPTS-1; // = CONCEPTS-1 = ONTOLOGIES
	static int TEST_RULES = 										TEST_CONCEPTS-1; // = CONCEPTS-1 = ONTOLOGIES
	static int TEST_MERGES = 										TEST_ONTOLOGIES-1; // = ONTOLOGIES-1

	public static void init(int f, int t, int w, boolean r) throws Exception
	{
		factor = f;
		n_times = t;
		restore = r;
		warming = w;

		// The initial state factor is the greatest of the two factors, 
		// taking into account the warming.
		if ((factor-warming)>n_times){
			initial_state_factor = factor;
		} else {
			initial_state_factor = n_times+warming;
		}
		
		TEST_ONTOLOGIES = n_times;
		TEST_CONCEPTS = 									TEST_ONTOLOGIES; // = ONTOLOGIES
		TEST_TERM_REFERENCES = 						TEST_CONCEPTS; // = ONTOLOGIES = CONCEPTS
		TEST_ONTOLOGY_REFERENCES = 				TEST_ONTOLOGIES; // = ONTOLOGIES
		TEST_TERM_REFERENCE_RELATIONS =  	TEST_TERM_REFERENCES; // = ONTOLOGIES = CONCEPTS = TERM_REFERENCES 
		TEST_TERM_RELATIONS = 						TEST_CONCEPTS; // = CONCEPTS-1 = ONTOLOGIES
		TEST_CLASS_ATTRIBUTES = 					TEST_CONCEPTS; // = CONCEPTS = ONTOLOGIES
		TEST_CLASS_ATTRIBUTE_VALUES = 		TEST_CLASS_ATTRIBUTES; // = CLASS_ATTRIBUTES
		TEST_INSTANCE_ATTRIBUTES = 				TEST_CONCEPTS; // = CONCEPTS
		TEST_INSTANCE_ATTRIBUTE_VALUES = 	TEST_INSTANCE_ATTRIBUTES; // = INSTANCE_ATTRIBUTES
		TEST_SYNONYMS = 									TEST_CONCEPTS; // = CONCEPTS
		TEST_IMPORTED_TERMS = 						TEST_ONTOLOGIES; // = ONTOLOGIES
		TEST_CONSTANTS = 									TEST_ONTOLOGIES; // = ONTOLOGIES
		TEST_FORMULAS = 									TEST_CONCEPTS; // = ONTOLOGIES
		TEST_FORMULA_RELATIONS = 					TEST_FORMULAS; // = ONTOLOGIES = CONCEPTS = FORMULAS
		TEST_INSTANCE_SETS = 							TEST_ONTOLOGIES; // Not tested but used for TEST_INSTANCES
		TEST_INSTANCES = 									TEST_ONTOLOGIES; // = ONTOLOGIES = INSTANCE_SETS
		TEST_RELATION_INSTANCES = 				TEST_INSTANCES; // = TERM_RELATIONS = INSTANCES-1 = ONTOLOGIES = INSTANCE_SETS
		TEST_INSTANCE_VALUES = 						TEST_INSTANCE_ATTRIBUTES; // = ONTOLOGIES = INSTANCE_ATTRIBUTES
		TEST_GROUPS = 										TEST_CONCEPTS; // = ONTOLOGIES = CONCEPTS
		TEST_AXIOMS = 										TEST_CONCEPTS; // = CONCEPTS-1 = ONTOLOGIES
		TEST_RULES = 											TEST_CONCEPTS; // = CONCEPTS-1 = ONTOLOGIES
		TEST_MERGES = 										TEST_ONTOLOGIES; // = ONTOLOGIES-1
	}
}
