package es.upm.fi.dia.ontology.webode.wpbs;

// Java stuff
import java.util.Calendar;
import java.util.Date;

import es.upm.fi.dia.ontology.minerva.client.MinervaClient;
import es.upm.fi.dia.ontology.minerva.server.MinervaSession;
import es.upm.fi.dia.ontology.minerva.server.MinervaURL;
import es.upm.fi.dia.ontology.webode.service.ODEService;

public class runBenchmark
{

	/**
	 *	Runs all the benchmarks in the Inserts group
	 *
	 *	@param odeService The ODE service
	 */
	private static void run_benchmarks_inserts(ODEService odeService) throws Exception
	{
		benchmarkBasicInsert.benchmark1_1_01(odeService);
		benchmarkBasicInsert.benchmark1_1_02(odeService);
		benchmarkBasicInsert.benchmark1_1_03(odeService);
		benchmarkBasicInsert.benchmark1_1_04(odeService);
		benchmarkBasicInsert.benchmark1_1_05(odeService);
		benchmarkBasicInsert.benchmark1_1_06(odeService);
		benchmarkBasicInsert.benchmark1_1_07(odeService);
		benchmarkBasicInsert.benchmark1_1_08(odeService);
		benchmarkBasicInsert.benchmark1_1_09(odeService);
		benchmarkBasicInsert.benchmark1_1_10(odeService);
		benchmarkBasicInsert.benchmark1_1_11(odeService);
		benchmarkBasicInsert.benchmark1_1_12(odeService);
		benchmarkBasicInsert.benchmark1_1_13(odeService);
		benchmarkBasicInsert.benchmark1_1_14(odeService);
		benchmarkBasicInsert.benchmark1_1_15(odeService);
		benchmarkBasicInsert.benchmark1_1_16(odeService);
		benchmarkBasicInsert.benchmark1_1_17(odeService);
		benchmarkBasicInsert.benchmark1_1_18(odeService);
		benchmarkBasicInsert.benchmark1_1_19(odeService);
		benchmarkBasicInsert.benchmark1_1_20(odeService);
		benchmarkBasicInsert.benchmark1_1_21(odeService);
		benchmarkBasicInsert.benchmark1_1_22(odeService);
		benchmarkBasicInsert.benchmark1_1_23(odeService);
		benchmarkBasicInsert.benchmark1_1_24(odeService);
		benchmarkBasicInsert.benchmark1_1_25(odeService);
		benchmarkBasicInsert.benchmark1_1_26(odeService);
		benchmarkBasicInsert.benchmark1_1_27(odeService);
		benchmarkBasicInsert.benchmark1_1_28(odeService);
		benchmarkBasicInsert.benchmark1_1_29(odeService);
		benchmarkBasicInsert.benchmark1_1_30(odeService);
		benchmarkBasicInsert.benchmark1_1_31(odeService);
		benchmarkBasicInsert.benchmark1_1_32(odeService);
		benchmarkBasicInsert.benchmark1_1_33(odeService);
		benchmarkBasicInsert.benchmark1_1_34(odeService);
		benchmarkBasicInsert.benchmark1_1_35(odeService);
		benchmarkBasicInsert.benchmark1_1_36(odeService);
		benchmarkBasicInsert.benchmark1_1_37(odeService);
	}

	/**
	 *	Runs n times the benchmarks in the Inserts group
	 *
	 *	@param odeService The ODE service
	 *	@param n The number of times the benchmarks are run
	 *	@param factor The execution factor of the benchmarks
	 *
	private static void test_n_times_inserts(ODEService odeService, int n, int factor) throws Exception
	{
		String f = Integer.toString(factor);
		if (f.length() <= 1) f = "000"+f;
		if (f.length() <= 2) f = "00"+f;
		if (f.length() <= 3) f = "0"+f;

		// Runs the benchmarks n times
		for (int i = 1; i<=n; i++){

			String s = Integer.toString(i);
			if (s.length() <= 1) s = "00"+s;
			if (s.length() <= 2) s = "0"+s;

			// Updates the destination dir of the timer
			benchmarkConstants.timer_destination_dir = benchmarkConstants.destination_dir +
																								 "f"+f+java.io.File.separator+
																								 "inserts"+s+java.io.File.separator;

			// Creates the destination dir if it doesn't exists
			File dir = new File(benchmarkConstants.timer_destination_dir);
			if (!(dir.exists() && dir.isDirectory())) dir.mkdirs() ;

			// Sets the initial state deleting the ontologies in the database and
			// inserting the minimal initial state
			benchmarkInitialState.deleteOntologies(odeService);
			benchmarkInitialState.initialStateBasicInsertMinimal(odeService);

			// Runs the benchmarks
			test_inserts(odeService);
		}
	}*/

	/**
	 *	Runs the benchmarks in the Inserts group
	 *
	 *	@param odeService The ODE service
	 *	@param n The number of times the benchmarks are run
	 *
	private static void benchmark_inserts(ODEService odeService) throws Exception
	{
		// Sets the initial state deleting the ontologies in the database and
		// inserting the minimal initial state
		benchmarkInitialState.deleteOntologies(odeService);
		benchmarkInitialState.initialStateCommonMinimal(odeService);

		// Runs the benchmarks
		run_benchmarks_inserts(odeService);
	}*/

	/**
	 *	Runs all the benchmarks in the Updates group
	 *
	 *	@param odeService The ODE service
	 */
	private static void run_benchmarks_updates(ODEService odeService) throws Exception
	{
		benchmarkBasicUpdate.benchmark1_2_01(odeService);
		benchmarkBasicUpdate.benchmark1_2_02(odeService);
		benchmarkBasicUpdate.benchmark1_2_03(odeService);
		benchmarkBasicUpdate.benchmark1_2_04(odeService);
		benchmarkBasicUpdate.benchmark1_2_05(odeService);
		benchmarkBasicUpdate.benchmark1_2_06(odeService);
		benchmarkBasicUpdate.benchmark1_2_07(odeService);
		benchmarkBasicUpdate.benchmark1_2_08(odeService);
		benchmarkBasicUpdate.benchmark1_2_09(odeService);
		benchmarkBasicUpdate.benchmark1_2_10(odeService);
		benchmarkBasicUpdate.benchmark1_2_11(odeService);
		benchmarkBasicUpdate.benchmark1_2_12(odeService);
		benchmarkBasicUpdate.benchmark1_2_13(odeService);
		benchmarkBasicUpdate.benchmark1_2_14(odeService);
		benchmarkBasicUpdate.benchmark1_2_15(odeService);
		benchmarkBasicUpdate.benchmark1_2_16(odeService);
		benchmarkBasicUpdate.benchmark1_2_17(odeService);
		benchmarkBasicUpdate.benchmark1_2_18(odeService);
	}

	/**
	 *	Runs n times the benchmarks in the Updates group
	 *
	 *	@param odeService The ODE service
	 *	@param n The number of times the benchmarks are run
	 *	@param factor The execution factor of the benchmarks
	 *
	private static void test_n_times_updates(ODEService odeService, int n, int factor) throws Exception
	{
		String f = Integer.toString(factor);
		if (f.length() <= 1) f = "000"+f;
		if (f.length() <= 2) f = "00"+f;
		if (f.length() <= 3) f = "0"+f;

		// Runs the benchmarks n times
		for (int i = 1; i<=n; i++){

			String s = Integer.toString(i);
			if (s.length() <= 1) s = "00"+s;
			if (s.length() <= 2) s = "0"+s;

			// Updates the destination dir of the timer
			benchmarkConstants.timer_destination_dir = benchmarkConstants.destination_dir +
																								 "f"+f+java.io.File.separator+
																								 "updates"+s+java.io.File.separator;

			// Creates the destination dir if it doesn't exists
			File dir = new File(benchmarkConstants.timer_destination_dir);
			if (!(dir.exists() && dir.isDirectory())) dir.mkdirs() ;

			// Sets the initial state deleting the ontologies in the database and
			// inserting the minimal initial state
			benchmarkInitialState.deleteOntologies(odeService);
			benchmarkInitialState.initialStateBasicUpdateMinimal(odeService);

			// Runs the benchmarks
			test_updates(odeService);
		}
	}	*/

	/**
	 *	Runs all the benchmarks in the Removals group
	 *
	 *	@param odeService The ODE service
	 */
	private static void run_benchmarks_removals(ODEService odeService) throws Exception
	{
		benchmarkBasicRemove.benchmark1_3_02(odeService);
		benchmarkBasicRemove.benchmark1_3_03(odeService);
		benchmarkBasicRemove.benchmark1_3_04(odeService);
		benchmarkBasicRemove.benchmark1_3_05(odeService);
		benchmarkBasicRemove.benchmark1_3_06(odeService);
		benchmarkBasicRemove.benchmark1_3_07(odeService);
		benchmarkBasicRemove.benchmark1_3_08(odeService);
		benchmarkBasicRemove.benchmark1_3_09(odeService);
		benchmarkBasicRemove.benchmark1_3_10(odeService);
		benchmarkBasicRemove.benchmark1_3_11(odeService);
		benchmarkBasicRemove.benchmark1_3_12(odeService);
		benchmarkBasicRemove.benchmark1_3_13(odeService);
		benchmarkBasicRemove.benchmark1_3_14(odeService);
		benchmarkBasicRemove.benchmark1_3_15(odeService);
		benchmarkBasicRemove.benchmark1_3_16(odeService);
		benchmarkBasicRemove.benchmark1_3_17(odeService);
		benchmarkBasicRemove.benchmark1_3_18(odeService);
		benchmarkBasicRemove.benchmark1_3_19(odeService);
		benchmarkBasicRemove.benchmark1_3_20(odeService);
		benchmarkBasicRemove.benchmark1_3_21(odeService);
		benchmarkBasicRemove.benchmark1_3_01(odeService);
	}

	/**
	 *	Runs n times the benchmarks in the Removals group
	 *
	 *	@param odeService The ODE service
	 *	@param n The number of times the benchmarks are run
	 *	@param factor The execution factor of the benchmarks
	 *
	private static void test_n_times_removals(ODEService odeService, int n, int factor) throws Exception
	{
		String f = Integer.toString(factor);
		if (f.length() <= 1) f = "000"+f;
		if (f.length() <= 2) f = "00"+f;
		if (f.length() <= 3) f = "0"+f;

		// Runs the benchmarks n times
		for (int i = 1; i<=n; i++){

			String s = Integer.toString(i);
			if (s.length() <= 1) s = "00"+s;
			if (s.length() <= 2) s = "0"+s;

			// Updates the destination dir of the timer
			benchmarkConstants.timer_destination_dir = benchmarkConstants.destination_dir +
																								 "f"+f+java.io.File.separator+
																								 "removals"+s+java.io.File.separator;

			// Creates the destination dir if it doesn't exists
			File dir = new File(benchmarkConstants.timer_destination_dir);
			if (!(dir.exists() && dir.isDirectory())) dir.mkdirs() ;

			// Sets the initial state deleting the ontologies in the database and
			// inserting the minimal initial state
			benchmarkInitialState.deleteOntologies(odeService);
			benchmarkInitialState.initialStateBasicRemoveMinimal(odeService);

			// Runs the benchmarks
			test_removals(odeService);
		}
	}	*/

	/**
	 *	Runs all the benchmarks in the Selects group
	 *
	 *	@param odeService The ODE service
	 */
	private static void run_benchmarks_selects(ODEService odeService) throws Exception
	{

		benchmarkBasicSelect.benchmark1_4_01(odeService);
		benchmarkBasicSelect.benchmark1_4_02(odeService);
		benchmarkBasicSelect.benchmark1_4_03(odeService);
		benchmarkBasicSelect.benchmark1_4_04(odeService);
		benchmarkBasicSelect.benchmark1_4_05(odeService);
		benchmarkBasicSelect.benchmark1_4_06(odeService);
		benchmarkBasicSelect.benchmark1_4_07(odeService);
		benchmarkBasicSelect.benchmark1_4_08(odeService);
		benchmarkBasicSelect.benchmark1_4_09(odeService);
		benchmarkBasicSelect.benchmark1_4_10(odeService);
		benchmarkBasicSelect.benchmark1_4_11(odeService);
		benchmarkBasicSelect.benchmark1_4_12(odeService);
		benchmarkBasicSelect.benchmark1_4_13(odeService);
		benchmarkBasicSelect.benchmark1_4_14(odeService);
		benchmarkBasicSelect.benchmark1_4_15(odeService);
		benchmarkBasicSelect.benchmark1_4_16(odeService);
		benchmarkBasicSelect.benchmark1_4_17(odeService);
		benchmarkBasicSelect.benchmark1_4_18(odeService);
		benchmarkBasicSelect.benchmark1_4_19(odeService);
		benchmarkBasicSelect.benchmark1_4_20(odeService);
		benchmarkBasicSelect.benchmark1_4_21(odeService);
		benchmarkBasicSelect.benchmark1_4_22(odeService);
		benchmarkBasicSelect.benchmark1_4_23(odeService);
		benchmarkBasicSelect.benchmark1_4_24(odeService);
		benchmarkBasicSelect.benchmark1_4_25(odeService);
		benchmarkBasicSelect.benchmark1_4_26(odeService);
		benchmarkBasicSelect.benchmark1_4_27(odeService);
		benchmarkBasicSelect.benchmark1_4_28(odeService);
		benchmarkBasicSelect.benchmark1_4_29(odeService);
		benchmarkBasicSelect.benchmark1_4_30(odeService);
		benchmarkBasicSelect.benchmark1_4_31(odeService);
		benchmarkBasicSelect.benchmark1_4_32(odeService);
		benchmarkBasicSelect.benchmark1_4_33(odeService);
		benchmarkBasicSelect.benchmark1_4_34(odeService);
		benchmarkBasicSelect.benchmark1_4_35(odeService);
		benchmarkBasicSelect.benchmark1_4_36(odeService);
		benchmarkBasicSelect.benchmark1_4_37(odeService);
		benchmarkBasicSelect.benchmark1_4_38(odeService);
		benchmarkBasicSelect.benchmark1_4_39(odeService);
		benchmarkBasicSelect.benchmark1_4_40(odeService);
		benchmarkBasicSelect.benchmark1_4_41(odeService);
		benchmarkBasicSelect.benchmark1_4_42(odeService);
		benchmarkBasicSelect.benchmark1_4_43(odeService);
		benchmarkBasicSelect.benchmark1_4_44(odeService);
		benchmarkBasicSelect.benchmark1_4_45(odeService);
		benchmarkBasicSelect.benchmark1_4_46(odeService);
		benchmarkBasicSelect.benchmark1_4_47(odeService);
	}

	/**
	 *	Runs n times the benchmarks in the Selects group
	 *
	 *	@param odeService The ODE service
	 *	@param n The number of times the benchmarks are run
	 *	@param factor The execution factor of the benchmarks
	 *
	private static void test_n_times_selects(ODEService odeService, int n, int factor) throws Exception
	{
		String f = Integer.toString(factor);
		if (f.length() <= 1) f = "000"+f;
		if (f.length() <= 2) f = "00"+f;
		if (f.length() <= 3) f = "0"+f;

		// Runs the benchmarks n times
		for (int i = 1; i<=n; i++){

			String s = Integer.toString(i);
			if (s.length() <= 1) s = "00"+s;
			if (s.length() <= 2) s = "0"+s;

			// Updates the destination dir of the timer
			benchmarkConstants.timer_destination_dir = benchmarkConstants.destination_dir +
																								 "f"+f+java.io.File.separator+
																								 "selects"+s+java.io.File.separator;

			// Creates the destination dir if it doesn't exists
			File dir = new File(benchmarkConstants.timer_destination_dir);
			if (!(dir.exists() && dir.isDirectory())) dir.mkdirs() ;

			// Sets the initial state deleting the ontologies in the database and
			// inserting the minimal initial state
			benchmarkInitialState.deleteOntologies(odeService);
			benchmarkInitialState.initialStateBasicSelectMinimal(odeService);

			// Runs the benchmarks
			test_selects(odeService);
		}
	}	*/

	/**
	 *	Runs all the benchmarks in the Non basics group
	 *
	 *	@param odeService The ODE service
	 */
	private static void run_benchmarks_non_basics(ODEService odeService) throws Exception
	{
		benchmarkNonBasic.benchmark2_01(odeService);
		benchmarkNonBasic.benchmark2_02(odeService);
		benchmarkNonBasic.benchmark2_03(odeService);
		benchmarkNonBasic.benchmark2_04(odeService);
		benchmarkNonBasic.benchmark2_05(odeService);
	}

	/**
	 *	Runs n times the benchmarks in the Non basics group
	 *
	 *	@param odeService The ODE service
	 *	@param n The number of times the benchmarks are run
	 *	@param factor The execution factor of the benchmarks
	 *
	private static void test_n_times_non_basics(ODEService odeService, int n, int factor) throws Exception
	{
		String f = Integer.toString(factor);
		if (f.length() <= 1) f = "000"+f;
		if (f.length() <= 2) f = "00"+f;
		if (f.length() <= 3) f = "0"+f;

		// Runs the benchmarks n times
		for (int i = 1; i<=n; i++){

			String s = Integer.toString(i);
			if (s.length() <= 1) s = "00"+s;
			if (s.length() <= 2) s = "0"+s;

			// Updates the destination dir of the timer
			benchmarkConstants.timer_destination_dir = benchmarkConstants.destination_dir +
																								 "f"+f+java.io.File.separator+
																								 "non_basics"+s+java.io.File.separator;

			// Creates the destination dir if it doesn't exists
			File dir = new File(benchmarkConstants.timer_destination_dir);
			if (!(dir.exists() && dir.isDirectory())) dir.mkdirs() ;

			// Sets the initial state deleting the ontologies in the database and
			// inserting the minimal initial state
			benchmarkInitialState.deleteOntologies(odeService);
			benchmarkInitialState.initialStateNonBasicMinimal(odeService);

			// Runs the benchmarks
			test_non_basics(odeService);
		}
	}	*/

	/**
	 *	Runs all the benchmarks in the Complex group
	 *
	 *	@param ms The Minerva session
	 *
	private static void test_complex(MinervaSession ms) throws Exception
	{

		AxiomService axiomService = (AxiomService) ms.getService ("axiom");
		benchmarkComplex.benchmark3_01(axiomService);
		benchmarkComplex.benchmark3_02(axiomService);
		benchmarkComplex.benchmark3_03(axiomService);
		benchmarkComplex.benchmark3_04(axiomService);

		// minerva parece que no libera el servicio al usarlo o algo as
		// slo se puede ejecutar esto una vez sin tener que rearrancar minerva
		MergeService mergeService = (MergeService) ms.getService ("merge");
		benchmarkComplex.benchmark3_05(mergeService);

		ExportService exportService = (ExportService) ms.getService ("xml-export");
		benchmarkComplex.benchmark3_06(exportService);

		DAMLOILExportService damloilExportService = (DAMLOILExportService) ms.getService ("damloil");
		benchmarkComplex.benchmark3_07(damloilExportService);

		OILExportService oilExportService = (OILExportService) ms.getService ("oil");
		benchmarkComplex.benchmark3_08(oilExportService);

		PrologExportService prologExportService = (PrologExportService) ms.getService ("prolog");
		benchmarkComplex.benchmark3_09(prologExportService);

		XCARINExportService xcarinExportService = (XCARINExportService) ms.getService ("xcarin");
		benchmarkComplex.benchmark3_10(xcarinExportService);

		JessExportService jessExportService = (JessExportService) ms.getService ("jess");
		benchmarkComplex.benchmark3_11(jessExportService);


 		// Necesita tener introducida la ontologa 'top level of universals'
		OntoCleanService ocService = (OntoCleanService) ms.getService ("ontoclean");
		benchmarkComplex.benchmark3_12(ocService);
		benchmarkComplex.benchmark3_13(ocService);
		benchmarkComplex.benchmark3_14(ocService);
		// El siguiente mtodo peta aleatoriamente
//		benchmarkComplex.benchmark3_15(ocService);
		benchmarkComplex.benchmark3_16(ocService);
		benchmarkComplex.benchmark3_17(ocService);


		if (axiomService != null) axiomService.disconnect();
		if (mergeService != null) mergeService.disconnect();
		if (exportService != null) exportService.disconnect();
		if (damloilExportService != null) damloilExportService.disconnect();
		if (oilExportService != null) oilExportService.disconnect();
		if (prologExportService != null) prologExportService.disconnect();
		if (xcarinExportService != null) xcarinExportService.disconnect();
		if (jessExportService != null) jessExportService.disconnect();
		if (ocService != null) ocService.disconnect();
	}*/

	/**
	 *	Runs n times the benchmarks in the Complex group
	 *
	 *	@param ms The Minerva session
	 *	@param odeService The ODE service
	 *	@param n The number of times the benchmarks are run
	 *	@param factor The execution factor of the benchmarks
	 *
	private static void test_n_times_complex(MinervaSession ms, ODEService odeService, int n, int factor) throws Exception
	{
		String f = Integer.toString(factor);
		if (f.length() <= 1) f = "000"+f;
		if (f.length() <= 2) f = "00"+f;
		if (f.length() <= 3) f = "0"+f;

		// Runs the benchmarks n times
		for (int i = 1; i<=n; i++){

			String s = Integer.toString(i);
			if (s.length() <= 1) s = "00"+s;
			if (s.length() <= 2) s = "0"+s;

			// Updates the destination dir of the timer
			benchmarkConstants.timer_destination_dir = benchmarkConstants.destination_dir +
																								 "f"+f+java.io.File.separator+
																								 "complex"+s+java.io.File.separator;

			// Creates the destination dir if it doesn't exists
			File dir = new File(benchmarkConstants.timer_destination_dir);
			if (!(dir.exists() && dir.isDirectory())) dir.mkdirs() ;

			// Para ejecutar los complejos hay que meter la top_level_ontology_of_universals antes
			// Sets the initial state deleting the ontologies in the database and
			// inserting the minimal initial state
//			benchmarkInitialState.deleteOntologies(odeService);
//			benchmarkInitialState.initialStateComplex(odeService);

			// Runs the benchmarks
			test_complex(ms);
		}
	}	*/

  public static void main (String[] args) throws Exception
  {
    int i=0;
    String arg;
    boolean error = false;

    int factor = 0;
    int n_times = 0;
    int warming = 100;
    boolean restore = false;

    // Check the arguments
    while (i<args.length && args[i].startsWith("-") && !error){
      arg = args[i];
      i++;

      if (arg.equals("-factor")){
        if (i<args.length){
          try{
            factor = Integer.parseInt(args[i]);
            i++;
          } catch (NumberFormatException e) {
            System.err.println("ERROR: -factor must be followed by an integer");
            error = true;
          }
        } else {
          System.err.println("ERROR: -factor must be followed by an integer");
          error = true;
        }
      } else {
        if (arg.equals("-n_times")){
          if (i<args.length){
            try{
              n_times = Integer.parseInt(args[i]);
              i++;
            } catch (NumberFormatException e) {
              System.err.println("ERROR: -n_times must be followed by an integer");
              error = true;
            }
          } else {
          System.err.println("ERROR: -n_times must be followed by an integer");
          error = true;
        }
        } else {
          if (arg.equals("-warming")){
            if (i<args.length){
              try{
                warming = Integer.parseInt(args[i]);
                i++;
              } catch (NumberFormatException e) {
                System.err.println("ERROR: -warming must be followed by an integer");
                error = true;
              }
            } else {
              System.err.println("ERROR: -warming must be followed by an integer");
              error = true;
            }
          } else {
            if (arg.equals("-restore")){
              restore = true;
            }
          }
        }
      }
    }

    if (i != args.length || error || (factor == 0) || (n_times == 0)){
      System.err.println("Usage: WPBS -factor <factor> -n_times <n_times> [-warming <warming>] [-restore]");
      System.err.println("       -factor <factor> : Integer. The load factor of the benchmark suite");
      System.err.println("       -n_times <n_times> : Integer. The consecutive executions of a method in a benchmark");
      System.err.println("       -warming <warming> : Integer. The number of executions of a method in a benchmark before start measuring");
      System.err.println("       -restore : Boolean. The benchmarks restore the benchmark suite initial load state after their execution");
      System.exit(1);
    }

  	// Gets the Minerva session and the ODE service
		MinervaSession ms=null;
		ODEService odeService=null;

		try{
			ms = MinervaClient.getMinervaSession
						(new MinervaURL (benchmarkConstants.MINERVA_URL),
														 benchmarkConstants.MINERVA_USER,
														 benchmarkConstants.MINERVA_PASS);

			odeService = (ODEService) ms.getService ("ode");
		}
		catch (Exception e){
      throw new Exception("ERROR getting minerva session: "+e.getMessage());
		}

		Date start_time=Calendar.getInstance().getTime();

		// Sets the execution parameters
		factor = 3000;
		n_times = 400;

		benchmarkConstants.init(factor,n_times,warming,restore);

		/**
		 *	The following sentences run all the benchmarks except the complex ones
		 *	Only if the initial state is restored all the benchmarks can be run
		 */

		// Sets the initial state deleting the ontologies in the database and
		// inserting the minimal initial state
//		benchmarkInitialState.deleteOntologies(odeService);
//		benchmarkInitialState.initialStateCommonMinimal(odeService);

		// Runs the benchmarks
		run_benchmarks_inserts(odeService);
		run_benchmarks_updates(odeService);
		run_benchmarks_removals(odeService);
		run_benchmarks_selects(odeService);
		run_benchmarks_non_basics(odeService);
		// ---------------------------------------------------------------------- //

		/**
		 *	The following senteces run the complex benchmarks.
		 *	This is a three step procedure:
		 *	1.- Uncomment and run the first two sentences
		 *	2.- Import the ontology "top level of universals" in WebODE
		 *	3.- Comment the first two sentences and
		 *			uncomment and run the last sentence
		 */
//		benchmarkInitialState.deleteOntologies(odeService);
//		benchmarkInitialState.initialStateComplex(odeService);

//		test_n_times_complex(ms,odeService,1,factor);

		// ---------------------------------------------------------------------- //

		/**
		 *	The following sentences run all the benchmarks with a common initial state
		 */
//		benchmarkConstants.timer_destination_dir = benchmarkConstants.destination_dir;

//		benchmarkInitialState.deleteOntologies(odeService);
//		benchmarkInitialState.initialStateCommonMinimal(odeService);

//		test_updates(odeService);
//		test_selects(odeService);
//		test_non_basics(odeService);
//		test_complex(ms);
//		test_inserts(odeService);
//		test_removals(odeService);

		Date end_time=Calendar.getInstance().getTime();

		System.out.println("Start time: "+start_time);
		System.out.println("End time:   "+end_time);

                long hours, minutes, seconds;
		long timeInSeconds = (end_time.getTime()-start_time.getTime())/1000;
                hours = timeInSeconds / 3600;
                timeInSeconds = timeInSeconds - (hours * 3600);
                minutes = timeInSeconds / 60;
                timeInSeconds = timeInSeconds - (minutes * 60);
                seconds = timeInSeconds;
                System.out.println("Duration:    "+hours + "h " + minutes + "' " + seconds + "''");

		// Releases the session and the service
		if (odeService != null) odeService.disconnect();
		if (ms != null) ms.disconnect();

		System.out.println("Press <Enter> to continue");
		try {System.in.read();} catch (Exception e) {}

	}

}
